<script lang="ts">
import Vue from 'vue';
import { MetaInfo } from 'vue-meta/types/vue-meta';
import {
  ComparisonHero,
  ComparisonAnalysis,
  CompetitorCards,
  TabsIntro,
  Legend,
} from '~/components/competition/index.vue';
import { NextStep } from '~/components/common/index';

import { getPageMetadata } from '~/common/meta';

export default Vue.extend({
  components: {
    ComparisonHero,
    ComparisonAnalysis,
    NextStep,
    CompetitorCards,
    TabsIntro,
    Legend,
  },
  nuxtI18n: false,
  async asyncData({ $content, params, error }: any) {
    try {
      const templateData = await $content('competition/base_template').fetch();
      const comparisonData = await $content(
        `competition/${params.slug}`,
      ).fetch();

      const data = { ...templateData.data, ...comparisonData.data };
      const vs = `GitLab vs. ${comparisonData.data.competitor}`;
      data.title = vs;
      data.crumbs.push({ title: vs });

      if (
        data.competitor_product === undefined ||
        data.competitor_product === ''
      ) {
        data.competitor_product = data.competitor;
      }

      return { data };
    } catch (e) {
      return error({ statusCode: 404 });
    }
  },
  head(): MetaInfo {
    return getPageMetadata((this as any).data, this.$route.path);
  },
});
</script>

<template>
  <div>
    <ComparisonHero :data="data" />
    <SlpContainer v-if="data.gitlab_coverage && data.competitor_coverage">
      <TabsIntro :data="data" />
    </SlpContainer>
    <ComparisonAnalysis
      v-if="data.comparison_table[0].stage !== null"
      :data="data"
      :projection-base-data="data.projection"
    />
    <SlpContainer v-if="data.comparison_table[0].stage !== null">
      <Legend :data="data.legend" class="legend-card" />
    </SlpContainer>
    <SlpContainer
      v-if="data.competitor_cards"
      variant="light-purple-100"
      class="slp-my-96"
    >
      <CompetitorCards :data="data.competitor_cards" />
    </SlpContainer>
    <SlpContainer class="slp-mt-96 next-steps__container" variant="gradient">
      <NextStep />
    </SlpContainer>
    <SlpSideButton data-ga-name="to-top" data-ga-location="body" />
  </div>
</template>

<style scoped lang="scss">
.slp-top-btn {
  @media (max-width: $breakpoint-md) {
    display: none;
  }
}

.next-steps__container {
  @media (max-width: $breakpoint-md) {
    margin-top: 40px;
  }
}
.legend-card {
  border: 1px solid $color-surface-200;
  width: 50%;
  border-radius: $border-radius-4;
  padding: $spacing-32;
  margin-left: 16px;

  @media (max-width: $breakpoint-md) {
    width: 100%;
    margin-left: 0;
  }
}
</style>
